/**
 **	Database.H
 **
 **	Published / author: 2001-02-15 / grymse@telia.com
 **/

/*
Copyright (C) 2001  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _DATABASE_HH
#define _DATABASE_HH


	typedef struct opendbstruct
	{
		struct opendbstruct *next;
#ifdef _mysql_h
		MYSQL mysql;
#endif
		short busy;
	} OPENDB;


class Database {
public:
	Database::Database(void);
	Database::Database(char *h,char *u,char *p,char *d);
	Database::~Database(void);
	OPENDB *Database::grabdb(void);
	void Database::freedb(OPENDB *odb);
	short Database::errcode(void);
	void Database::debug(short val);
	short Database::debug(void);

private:
	char *host;
	char *user;
	char *password;
	char *database;
	OPENDB *opendbbase;
	short errc;
	short _debug;
#ifdef THREAD_SAFE
#ifdef USE_SDL
	SDL_mutex *m_lock;
	void Database::MutexLock() {
		SDL_mutexP(m_lock);
	}
	void Database::MutexUnlock() {
		SDL_mutexV(m_lock);
	}
#else
	pthread_mutex_t m_mutex;
	void Database::MutexLock() {
		pthread_mutex_lock(&m_mutex);
	}
	void Database::MutexUnlock() {
		pthread_mutex_unlock(&m_mutex);
	}
#endif // USE_SDL
#endif // THREAD_SAFE
};

#endif // _DATABASE_HH
